package com.github.jfcloud.excel.editor.docdeal.config;

import com.github.jfcloud.excel.editor.docdeal.oss.OssProperties;
import com.github.jfcloud.excel.editor.docdeal.oss.http.OssEndpoint;
import com.github.jfcloud.excel.editor.docdeal.oss.service.OssTemplate;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @author zj
 * @date 2023-4-25
 */
@Configuration
@EnableConfigurationProperties({OssProperties.class})
public class OssAutoConfiguration {
    private final OssProperties properties;

    @Bean
    @ConditionalOnMissingBean({OssTemplate.class})
    @ConditionalOnProperty(
            name = {"oss.enable"},
            havingValue = "true",
            matchIfMissing = true
    )
    public OssTemplate ossTemplate() {
        return new OssTemplate(this.properties);
    }

    @Bean
    @ConditionalOnProperty(
            name = {"oss.info"},
            havingValue = "true"
    )
    public OssEndpoint ossEndpoint(OssTemplate template) {
        return new OssEndpoint(template);
    }

    public OssAutoConfiguration(OssProperties properties) {
        this.properties = properties;
    }
}

